%define crontabs_version 20190603
%define _sbindir %{_bindir}

Name: cronie
Version: 1.5.5
Release: 4
License: BSD and GPLv2 and MIT
Summary: cron task scheduler
Url: https://github.com/cronie-crond/cronie

BuildRequires: automake
BuildRequires: autoconf

Requires: bash

Source0: https://github.com/cronie-crond/cronie/releases/download/cronie-%{version}/cronie-%{version}.tar.gz
Source1: https://github.com/cronie-crond/crontabs/archive/crontabs-%{crontabs_version}.tar.gz

Source10: obstack.c
Source11: obstack.h

Patch0: cronie-define-namemax.patch
Patch1: cronie-obstack.patch
Patch2: cronie-fix-groups.patch
Patch3: cronie-contrib-paths.patch
Patch4: cronie-crontabs-change-logger-facility.patch
Patch5: cronie-crontabs-fix-paths.patch
Patch6: cronie-crontab-skip-options-root-check.patch
Patch7: cronie-switch-root-username.patch

%description
cronie is a fork of and replacement for the venerable vixie-cron by Paul Vixie
It follows the standard cron conventions, supporting task scheduling.

%package anacron
Summary: runs commands periodically

Requires: %{name} = %{version}

%description anacron
Anacron is used to execute commands periodically, with a frequency specified in
days. Unlike cron, it does not assume that the machine is running continuously.

%prep
%setup -q -a 1

mv crontabs-crontabs-%{crontabs_version} crontabs

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

cp %{SOURCE10} anacron
cp %{SOURCE11} ./

autoreconf -fi

%build

%configure \
  CFLAGS="${CFLAGS} -DNAME_MAX=255" \
  LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib" \
  --enable-syscrontab

%make_build

%install

mkdir -pm700 %{buildroot}%{_localstatedir}/spool/cron
mkdir -pm700 %{buildroot}%{_localstatedir}/spool/anacron

mkdir -pm755 %{buildroot}%{_sysconfdir}/cron.d/
install -c -m644 contrib/0hourly %{buildroot}/%{_sysconfdir}/cron.d/0hourly
install -c -m644 contrib/dailyjobs %{buildroot}/%{_sysconfdir}/cron.d/dailyjobs

install -m 644 contrib/anacrontab %{buildroot}%{_sysconfdir}/anacrontab

mkdir -pm 755 %{buildroot}%{_sysconfdir}/cron.hourly
install -c -m755 contrib/0anacron %{buildroot}/%{_sysconfdir}/cron.hourly/0anacron

touch %{buildroot}/%{_localstatedir}/spool/anacron/cron.daily
touch %{buildroot}/%{_localstatedir}/spool/anacron/cron.weekly
touch %{buildroot}/%{_localstatedir}/spool/anacron/cron.monthly

touch %{buildroot}/%{_sysconfdir}/cron.deny

%make_install

# installing crontabs files
mkdir -p %{buildroot}%{_sysconfdir}/cron.hourly
mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
mkdir -p %{buildroot}%{_sysconfdir}/cron.weekly
mkdir -p %{buildroot}%{_sysconfdir}/cron.monthly
mkdir -p %{buildroot}%{_mandir}/man4
 
install -m644 ./crontabs/crontab %{buildroot}%{_sysconfdir}/crontab
install -m755 ./crontabs/run-parts %{buildroot}%{_bindir}/run-parts
install -m644 ./crontabs/crontabs.4 %{buildroot}%{_mandir}/man4/
install -m644 ./crontabs/run-parts.4 %{buildroot}%{_mandir}/man4/


%files
%defattr(-, qsys, *none)

%doc AUTHORS
%doc README
%doc ChangeLog

%license COPYING

%{_bindir}/crond
%{_bindir}/crontab
%{_bindir}/cronnext
%{_bindir}/run-parts

%dir %{_localstatedir}/spool/cron
%config(noreplace) %{_sysconfdir}/cron.deny

%dir %{_sysconfdir}/cron.d/
%config(noreplace) %{_sysconfdir}/cron.d/0hourly
%config(noreplace) %{_sysconfdir}/cron.d/dailyjobs
%dir %{_sysconfdir}/cron.hourly
%dir %{_sysconfdir}/cron.daily
%dir %{_sysconfdir}/cron.weekly
%dir %{_sysconfdir}/cron.monthly
%config(noreplace) %{_sysconfdir}/crontab

%{_mandir}/man1/crontab.1*
%{_mandir}/man1/cronnext.1*
%{_mandir}/man4/crontabs.4*
%{_mandir}/man4/run-parts.4*
%{_mandir}/man5/crontab.5*
%{_mandir}/man8/crond.8*
%{_mandir}/man8/cron.8*


%files anacron
%defattr(-, qsys, *none)

%{_bindir}/anacron

%dir %{_localstatedir}/spool/anacron
%ghost %verify(not md5 size mtime) %{_localstatedir}/spool/anacron/cron.daily
%ghost %verify(not md5 size mtime) %{_localstatedir}/spool/anacron/cron.weekly
%ghost %verify(not md5 size mtime) %{_localstatedir}/spool/anacron/cron.monthly

%{_sysconfdir}/cron.hourly/0anacron

%config(noreplace) %{_sysconfdir}/anacrontab

%{_mandir}/man5/anacrontab.5*
%{_mandir}/man8/anacron.8*


%changelog
* Mon Dec 07 2020 Mark Irish <mirish@ibm.com> - 1.5.5
- Fix crontab -u and -n options
- Check that files are owned by qsys instead of root
- Ship cron.deny
- Change permissions on 0hourly and dailyjobs so crond will run them

* Tue Jul 14 2020 Mark Irish <mirish@ibm.com> - 1.5.5
- Include crontabs in the base cronie package
- Ship dailyjobs and /QOpenSys/etc/cron.{daily,monthly,yearly} in base package

* Wed Jul 08 2020 Mark Irish <mirish@ibm.com> - 1.5.5
- Move binaries from /QOpenSys/pkgs/sbin to /QOpenSys/pkgs/bin
- Ship additional configuration and documentation files
- Make spool/anacron/ files %ghost'ed and not verified on md5, size, mtime

* Tue Jun 16 2020 Mark Irish <mirish@ibm.com> - 1.5.5
- Update to v1.5.5
- Fixes CVE-2019-9704
- Fixes CVE-2019-9705
- Ship connext (new)

* Tue Jun 16 2020 Mark Irish <mirish@ibm.com> - 1.5.1
- Split anacron into a subpackage

* Wed May 27 2020 Kevin Adler <kadler@us.ibm.com> - 1.5.1
- Use generic paths for man and info pages to allow for compression

* Tue Mar 10 2020 Jesse Gorzinski <jgorzins@us.ibm.com> - 1.5.1
- Initial release
